class EmpleadoEventual extends Empleado{
   final float PRECIO_HORA = 30;	
   private int horasTrabajadas = 0;

   EmpleadoEventual(long id,String n, int h){
      super(id,n);
      horasTrabajadas = h;
   }
   
   void aumentarSueldo(int horas){
      this.sueldo = this.sueldo + (horas * this.PRECIO_HORA);
   }

   
   int getHorasTrabajadas(){
      return horasTrabajadas;
   }
   
   void setHorasTrabajadas(int h){
   	  horasTrabajadas = h;
   }
   
   void calcularSueldo(){
   	  sueldo = horasTrabajadas * PRECIO_HORA;
   }
   
   public String toString(){
      return super.toString() +
   	          "\nHoras: " + horasTrabajadas;
   }  
   
   public static void main(String args[]){
       EmpleadoEventual e = new EmpleadoEventual(12345,"Juan de Juanes", 10);
       System.out.println(e);
       
       e.calcularSueldo();
       System.out.println(e);
       
       e.aumentarSueldo(5);
       System.out.println(e);
       
       e.calcularSueldo();
       System.out.println(e);
   }

}