import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class VentanaPrincipal{
	static FrameEmpleado frm;
	static Empresa e;
	public static void main(String args[]){
		//Crea una nueva empresa de 10 empleados
		e = new Empresa(10);
		
		frm = new FrameEmpleado();
		frm.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frm.show();
    }
}

class FrameEmpleado extends JFrame{
	
	PanelEmpleadoF pnlFijo = new PanelEmpleadoF();
	PanelEmpleadoE pnlEvent = new PanelEmpleadoE();
	PanelSeleccion pnlSel = new PanelSeleccion();
	PanelBotones pnlbtn = new PanelBotones();
	Box b1 = Box.createHorizontalBox();	
	
	FrameEmpleado(){
		setTitle("Empleado");
		setResizable(false);
		getContentPane().setLayout(new BorderLayout());
		Box box = Box.createVerticalBox();
		
		b1.add(pnlSel);
		b1.add(pnlFijo);
		b1.add(pnlEvent);
		pnlEvent.setVisible(false);
		pnlFijo.setVisible(true);
		
		box.add(b1);
		box.add(Box.createGlue());
		box.add(pnlbtn);
				
		getContentPane().add(box);
		//setSize(460,250); 
		pack();
	}
}

class PanelEmpleadoF extends JPanel{
	JLabel lblID = new JLabel("ID. empleado: ",JLabel.RIGHT);
	JLabel lblNombre = new JLabel("Nombre: ",JLabel.RIGHT);
	JLabel lblSueldo = new JLabel("Sueldo: ",JLabel.RIGHT);
	JLabel lblComplemento = new JLabel("Complemento: ",JLabel.RIGHT);
	JLabel lblHoras = new JLabel("Horas:   ");
	JTextField txtID = new JTextField(20);
	JTextField txtNombre = new JTextField(20);
	JTextField txtSueldo = new JTextField(20);
	JTextField txtComplemento = new JTextField(20);
	JTextField txtHoras = new JTextField(20);
			
	PanelEmpleadoF(){
		Box caja = Box.createVerticalBox();
		caja.add(Box.createVerticalStrut(5));
		
		Box b1 = Box.createHorizontalBox();
		b1.add(Box.createHorizontalStrut(5));
		b1.add(lblID);
		txtID.setMaximumSize(txtID.getPreferredSize());	
		b1.add(Box.createGlue());	
		b1.add(txtID);
		b1.add(Box.createHorizontalStrut(5));
		caja.add(b1);
		caja.add(Box.createVerticalStrut(5));
		
		Box b2 = Box.createHorizontalBox();
		b2.add(Box.createHorizontalStrut(5));
		b2.add(lblNombre);
		txtNombre.setMaximumSize(txtNombre.getPreferredSize());
		b2.add(Box.createGlue());
		b2.add(txtNombre);
		b2.add(Box.createHorizontalStrut(5));
		caja.add(b2);
		caja.add(Box.createVerticalStrut(5));
		
		Box b3 = Box.createHorizontalBox();
		b3.add(Box.createHorizontalStrut(5));
		b3.add(lblSueldo);
		txtSueldo.setMaximumSize(txtSueldo.getPreferredSize());			
		b3.add(Box.createGlue());
		b3.add(txtSueldo);
		b3.add(Box.createHorizontalStrut(5));
		caja.add(b3);
		caja.add(Box.createVerticalStrut(5));
		
		Box b4 = Box.createHorizontalBox();
		b4.add(Box.createHorizontalStrut(5));
		b4.add(lblComplemento);	
		b4.add(Box.createGlue());	
		b4.add(txtComplemento);
		txtComplemento.setMaximumSize(txtComplemento.getPreferredSize());
		b4.add(Box.createHorizontalStrut(5));
		caja.add(b4);
		caja.add(Box.createRigidArea(new Dimension(20,5)));
		caja.add(Box.createRigidArea(new Dimension(20,5)));

		add(caja);
		setVisible(true);	
	}
}

class PanelEmpleadoE extends JPanel{
	JLabel lblID = new JLabel("ID. empleado: ",JLabel.RIGHT);
	JLabel lblNombre = new JLabel("Nombre: ",JLabel.RIGHT);
	JLabel lblSueldo = new JLabel("Sueldo: ",JLabel.RIGHT);
	JLabel lblHoras = new JLabel("Horas:   ");
	JTextField txtID = new JTextField(20);
	JTextField txtNombre = new JTextField(20);
	JTextField txtSueldo = new JTextField(20);
	JTextField txtHoras = new JTextField(20);

	PanelEmpleadoE(){
		Box caja = Box.createVerticalBox();
		caja.add(Box.createVerticalStrut(5));
		
		Box b1 = Box.createHorizontalBox();
		b1.add(Box.createHorizontalStrut(5));
		b1.add(lblID);
		txtID.setMaximumSize(txtID.getPreferredSize());	
		b1.add(Box.createGlue());	
		b1.add(txtID);
		b1.add(Box.createHorizontalStrut(5));
		caja.add(b1);
		caja.add(Box.createVerticalStrut(5));
		
		Box b2 = Box.createHorizontalBox();
		b2.add(Box.createHorizontalStrut(5));
		b2.add(lblNombre);
		txtNombre.setMaximumSize(txtNombre.getPreferredSize());
		b2.add(Box.createGlue());
		b2.add(txtNombre);
		b2.add(Box.createHorizontalStrut(5));
		caja.add(b2);
		caja.add(Box.createVerticalStrut(5));
				
		Box b4 = Box.createHorizontalBox();
		b4.add(Box.createHorizontalStrut(5));
		b4.add(lblHoras);	
		b4.add(Box.createGlue());	
		b4.add(txtHoras);
		txtHoras.setMaximumSize(txtHoras.getPreferredSize());
		b4.add(Box.createHorizontalStrut(5));
		caja.add(b4);
		caja.add(Box.createRigidArea(new Dimension(20,5)));
		caja.add(Box.createRigidArea(new Dimension(20,5)));

		add(caja);
		setVisible(true);	
	}
}

class PanelSeleccion extends JPanel{
	static boolean fijo = true;
	ButtonGroup grupo = new ButtonGroup();
	JRadioButton opcFijo = new JRadioButton("Empleado fijo",true);
	JRadioButton opcEventual = new JRadioButton("Empleado eventual",false);

	PanelSeleccion(){
		Box caja = Box.createVerticalBox();
		grupo.add(opcFijo);
		grupo.add(opcEventual);
		caja.add(opcFijo);
		caja.add(opcEventual);
		add(caja);
		opcFijo.addItemListener(new SeleccionListener());
		opcEventual.addItemListener(new SeleccionListener());
		setSize(100,210);
	}
	
	class SeleccionListener implements ItemListener{
		
		public void itemStateChanged(ItemEvent e){
			Object source = e.getSource();
			
			if(source == opcEventual && e.getStateChange() == ItemEvent.SELECTED){
				VentanaPrincipal.frm.pnlFijo.setVisible(false);
				VentanaPrincipal.frm.pnlEvent.setVisible(true);
				VentanaPrincipal.frm.pack();
			}
			else{
				VentanaPrincipal.frm.pnlEvent.setVisible(false);
				VentanaPrincipal.frm.pnlFijo.setVisible(true);
				VentanaPrincipal.frm.pack();
			}
		}
	}
}


class PanelBotones extends JPanel{
	PanelBotones(){
		JButton btn = new JButton("Aceptar");
		JButton btnCancelar = new JButton("Cancelar");
		setLayout(new FlowLayout(FlowLayout.LEFT));
		add(btn); 
		add(btnCancelar);
		btn.addActionListener(new AceptarListener());
		
		btnCancelar.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				System.exit(0);
			}
		});

	}
}

class AceptarListener implements ActionListener{
	public void actionPerformed(ActionEvent e){
		Empleado emp = null;
			
		if(VentanaPrincipal.frm.pnlSel.opcFijo.isSelected()){
			long id = Long.parseLong(VentanaPrincipal.frm.pnlFijo.txtID.getText());
			String nom = new String(VentanaPrincipal.frm.pnlFijo.txtNombre.getText());
			double complemento = Double.parseDouble(VentanaPrincipal.frm.pnlFijo.txtComplemento.getText());
			double sueldo = Double.parseDouble(VentanaPrincipal.frm.pnlFijo.txtSueldo.getText());
			emp = new EmpleadoFijo(id,nom,complemento);
			emp.setSueldo(sueldo);
			limpiarCampos();
		}
		else{
			long id = Long.parseLong(VentanaPrincipal.frm.pnlEvent.txtID.getText());
			String nom = new String(VentanaPrincipal.frm.pnlEvent.txtNombre.getText());
			int horas = Integer.parseInt(VentanaPrincipal.frm.pnlEvent.txtHoras.getText());
			emp = new EmpleadoEventual(id,nom,horas);
			emp.calcularSueldo();
			limpiarCampos();
		}
		System.out.println(emp);
		Empresa.nomina[Empleado.cuantosEmpleados()] = emp;
		Empresa.listarEmpleados();
	}
	
	static void limpiarCampos(){
		if(VentanaPrincipal.frm.pnlSel.opcFijo.isSelected()){
			VentanaPrincipal.frm.pnlFijo.txtID.setText("");
			VentanaPrincipal.frm.pnlFijo.txtNombre.setText("");
			VentanaPrincipal.frm.pnlFijo.txtSueldo.setText("");
			VentanaPrincipal.frm.pnlFijo.txtComplemento.setText("");					
		}
		else{
			VentanaPrincipal.frm.pnlEvent.txtID.setText("");
			VentanaPrincipal.frm.pnlEvent.txtNombre.setText("");
			VentanaPrincipal.frm.pnlEvent.txtHoras.setText("");
		}
	}

}


		